var NRPhoneGapAPI_cookies = {};

function NRPhoneGapAPI(url)
{
    NRPhoneGapAPI.instance = this;

    this.onopen = null;
    this.onmessage = null;
    this.onerror = null;
    this.onclose = null;
    this.bufferedAmount = 0;

    // default to polling mode
    // on android, speed in native mode is similar to polling mode (50ms)
    // polling mode(25ms) can speed up 10%, but cpu usage increase to 3-4
    // in native mode, cpu usage is about 1-2, in 50ms polling mode it's 2-3
    NRPhoneGapAPI.instance.interval = setInterval(function(){
        var msg = window.PhoneGapAPI.Receive();
        while (msg != null) {
            NRPhoneGapAPI.__OnMessage({'data':msg});
            msg = window.PhoneGapAPI.Receive();
        }
    }, 25);

    setTimeout("NRPhoneGapAPI.onOpen()", 1);
}

// Simulate WebSocket
NRPhoneGapAPI.prototype.send = function(data)
{
    window.PhoneGapAPI.Send(data);
}

NRPhoneGapAPI.prototype.close = function()
{
    var req = {};
    req.type = "SignOut";
    window.PhoneGapAPI.Send(JSON.stringify(req));
}

NRPhoneGapAPI.onOpen = function()
{
    if (NRPhoneGapAPI.instance != null && NRPhoneGapAPI.instance.onopen != null)
    {
        NRPhoneGapAPI.instance.onopen();
    }
}

NRPhoneGapAPI.__OnClose = function()
{
    if (NRPhoneGapAPI.instance != null)
    {
        if (NRPhoneGapAPI.instance.interval != null)
        {
            clearInterval(NRPhoneGapAPI.instance.interval);
        }
        if (NRPhoneGapAPI.instance.onclose != null)
        {
            NRPhoneGapAPI.instance.onclose();
        }
        NRPhoneGapAPI.instance = null;
    }
}

NRPhoneGapAPI.__OnMessage = function(data)
{
    if (NRPhoneGapAPI.instance != null && NRPhoneGapAPI.instance.onmessage != null)
    {
        NRPhoneGapAPI.instance.onmessage(data);
    }
}

// Keyboard management
NRPhoneGapAPI.prototype.detectkeyboard = function()
{
    return window.PhoneGapAPI.DetectKeyboard();
}

NRPhoneGapAPI.prototype.showkeyboard = function(x, y)
{
    window.PhoneGapAPI.ShowKeyboard(x, y);
}

// the dummy callback js function for showkeyboard API.
// with this callback, the java API can show the softkeyboard
NRPhoneGapAPI.__OnShowKeyboard = function()
{
}

// the dummy callback js function for tap event.
// by making the js call, foce the webview lost focus, then hide the softkeyboard
NRPhoneGapAPI.__OnTouch = function()
{
}

// Cookie management, no polling mode here
NRPhoneGapAPI.loadCookies = function(callback)
{
    NRPhoneGapAPI.loadCookiesCallback = callback;
    var req = {};
    req.type = "LoadCookies";
    window.PhoneGapAPI.Send(JSON.stringify(req));    
}

NRPhoneGapAPI.__onLoadCookies = function(data)
{
    if (data != null && data > '') {
        try {
            NRPhoneGapAPI_cookies = JSON.parse(String.fromCharCode.apply(null, Base64.decode(data)));
        } catch(err) {
            // in case parse an invalid string
        }
    }
    if (typeof NRPhoneGapAPI.loadCookiesCallback === 'function') {
        NRPhoneGapAPI.loadCookiesCallback();
        delete NRPhoneGapAPI.loadCookiesCallback;
    }
}

NRPhoneGapAPI.saveCookies = function()
{
    var req = {};
    req.type = "SaveCookies";
    req.data = JSON.stringify(NRPhoneGapAPI_cookies);
    window.PhoneGapAPI.Send(JSON.stringify(req));    
}

NRPhoneGapAPI.setCookie = function(name, value)
{
    if (NRPhoneGapAPI_cookies[name] != value)
    {
        NRPhoneGapAPI_cookies[name] = value;
        NRPhoneGapAPI.saveCookies();
    }
}

NRPhoneGapAPI.getCookie = function(name)
{
    return NRPhoneGapAPI_cookies[name];
}

NRPhoneGapAPI.removeCookie = function(name)
{
    if (NRPhoneGapAPI_cookies[name] != undefined)
    {
        delete NRPhoneGapAPI_cookies[name];
        NRPhoneGapAPI.saveCookies();
    }
}
